
import unittest
import json

from geniusweb.progress.Progress import Progress
from geniusweb.progress.ProgressRounds import ProgressRounds
from pyson.ObjectMapper import ObjectMapper
from datetime import datetime

class ProgressRoundsTest(unittest.TestCase):

    def setUp(self):
        self.pyson = ObjectMapper()
        self.progresjson = {"ProgressRounds":{"duration":12,"currentRound":0,"endtime":1999}}
        self.progress = ProgressRounds(12, 0, datetime.fromtimestamp(1.999))

    def testDeserialization(self):
        self.assertEqual(self.progress,self.pyson.parse(self.progresjson, Progress))

    def testSerialization(self):
        print(self.pyson.toJson(self.progress))
        self.assertEqual(self.progresjson, self.pyson.toJson(self.progress))
